Description

It's common to have a non-admin user with specific role trying to perform a specific task through API and in case of exporting some

content ( library\repo\cv version ), When using "Content Exporter" role with an user, then export attempt via that user will always end

up failing with errors like this i.e.

Could not export the repository:

  Validation failed: Label has already been taken, Name has already been taken

 Trace:

2024-05-09T16:00:45 [I|aud|4e8d0c49] Katello::ContentView (10) create event on generated_for 2

2024-05-09T16:00:45 [I|aud|4e8d0c49] Katello::ContentView (10) create event on repository_ids []

2024-05-09T16:00:45 [I|aud|4e8d0c49] Katello::ContentView (10) create event on environment_ids []

2024-05-09T16:00:45 [I|aud|4e8d0c49] Katello::ContentView (10) create event on filter_ids []

2024-05-09T16:00:45 [E|bac|4e8d0c49] Validation failed: Label has already been taken, Name has alr

eady been taken (ActiveRecord::RecordInvalid)

 4e8d0c49 | /usr/share/gems/gems/activerecord-6.1.7.6/lib/active_record/validations.rb:80:in `rais

e_validation_error'

 4e8d0c49 | /usr/share/gems/gems/activerecord-6.1.7.6/lib/active_record/validations.rb:53:in `save

!'

 4e8d0c49 | /usr/share/gems/gems/activerecord-6.1.7.6/lib/active_record/transactions.rb:302:in `bl

ock in save!'

 4e8d0c49 | /usr/share/gems/gems/activerecord-6.1.7.6/lib/active_record/transactions.rb:354:in `bl

ock in with_transaction_returning_status'

 4e8d0c49 | /usr/share/gems/gems/activerecord-6.1.7.6/lib/active_record/connection_adapters/abstra

ct/database_statements.rb:318:in `transaction'

 4e8d0c49 | /usr/share/gems/gems/activerecord-6.1.7.6/lib/active_record/transactions.rb:350:in `wi

th_transaction_returning_status'

 4e8d0c49 | /usr/share/gems/gems/activerecord-6.1.7.6/lib/active_record/transactions.rb:302:in `sa

ve!'

 4e8d0c49 | /usr/share/gems/gems/activerecord-6.1.7.6/lib/active_record/suppressor.rb:48:in `save!

'

 4e8d0c49 | /usr/share/gems/gems/activerecord-6.1.7.6/lib/active_record/persistence.rb:639:in `blo

ck in update!'

 4e8d0c49 | /usr/share/gems/gems/activerecord-6.1.7.6/lib/active_record/transactions.rb:354:in `bl

ock in with_transaction_returning_status'

 4e8d0c49 | /usr/share/gems/gems/activerecord-6.1.7.6/lib/active_record/connection_adapters/abstra

ct/database_statements.rb:318:in `transaction'

 4e8d0c49 | /usr/share/gems/gems/activerecord-6.1.7.6/lib/active_record/transactions.rb:350:in `wi

th_transaction_returning_status'

 4e8d0c49 | /usr/share/gems/gems/activerecord-6.1.7.6/lib/active_record/persistence.rb:637:in `upd

ate!'

 4e8d0c49 | /usr/share/gems/gems/katello-4.11.0.9/app/lib/actions/pulp3/orchestration/content_view

_version/export_repository.rb:17:in `plan'
 This is because, When it was time to create the Content View, The user did not have enough permission to work with.

# hammer role filters --name "Content Exporter" 

----|----------------------|--------|------------|-----------|------------------|-----------------

------------------

ID  | RESOURCE TYPE        | SEARCH | UNLIMITED? | OVERRIDE? | ROLE             | PERMISSIONS     

                  

----|----------------------|--------|------------|-----------|------------------|-----------------

------------------

249 | Katello::ContentView | none   | yes        | no        | Content Exporter | view_content_vie

ws                

250 | Organization         | none   | yes        | no        | Content Exporter | export_content, 

view_organizations

251 | Katello::Product     | none   | yes        | no        | Content Exporter | view_products   

                  

----|----------------------|--------|------------|-----------|------------------|-----------------

------------------

We simply need to add create_content_views permission in that specific role.

Associated revisions

Revision c33c5aa1 - 05/13/2024 05:43 PM - Sayan Das

Fixes #37430 - Added create_content_views permission in Content Exporter role

History

#1 - 05/09/2024 10:44 AM - Sayan Das

- Description updated

#2 - 05/09/2024 10:57 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Pull request https://github.com/Katello/katello/pull/10991 added

#3 - 05/09/2024 11:06 AM - Sayan Das

- Found in Releases Katello 4.10.0, Katello 4.11.0, Katello 4.10.1 added

#4 - 05/13/2024 05:43 PM - The Foreman Bot

- Fixed in Releases Katello 4.13.0 added

#5 - 05/13/2024 06:00 PM - Sayan Das

- Status changed from Ready For Testing to Closed

Applied in changeset katello|c33c5aa151c81401ff9f9f5585b3f70dceb799bc.

#6 - 05/15/2024 05:34 PM - Partha Aji

- Target version set to Katello 4.12.1

- Triaged changed from No to Yes
